<?php

/**
 * Implementation of hook_keys_manage().
 */
function gproximity_keys_service() {
  return array(
    'gproximity' => array(
      'name' => t('gProximity'),
      'description' => t('Google Map Locations'),
    ),
  );
}

/**
 * Implementation of hook_views_style_plugins().
 *
 * Provide views plugins for locations we want handled by gProximity.
 */
function gproximity_views_style_plugins() {
  return array(
    'gproximity' => array(
      'name' => t('gProximity: Google Map Locations'),
      'theme' => 'gproximity_locator',
      'needs_table_header' => FALSE,
      'needs_fields' => TRUE,
    ),
  );
}
function gproximity_views_tables() {

}
function theme_gproximity_locator($view, $nodes, $type) {
  // Views Fields
  $fields = _views_get_fields();

  // Get gProximity
  $data = db_fetch_object(db_query("SELECT * FROM {gproximity} WHERE gpid = %d",$view->vid));

  // Get Groups
  $result = db_query("SELECT * FROM {gproximity_groups} WHERE gpid = %d", $view->vid);
  $groups = array();
  while ($row = db_fetch_object($result)) {
    $groups[] = $row;
  }

  $geoFields = array('lat'=>$data->geo_lat,'lng'=>$data->geo_lng);
  if ($data->additional_fields != NULL) {
    $geoFields = $geoFields + explode("|",$data->additional_fields);
  }

  // Check to see if any fields added to gProximity were removed from the view.
  foreach ($geoFields as $v) {
    $checkGeo = 0;
    foreach ($view->field as $value) {
      if ($value['queryname'] == $v) {
        $checkGeo = 1;
      }
    }
    if ($checkGeo == 0) {
      $output = t("This View's fields have been changed or just created. Please go !here and update/add fields for this gProximity view.", array('!here' => l(t('here'), 'admin/build/gproximity')));
      return $output;
    }
  }

  if ($type == 'page') {
    // dprint_r($view->field);
   //  dprint_r($view);
   // dprint_r($nodes);
    // dprint_r($data);
    // dprint_r($groups);
    // dprint_r($fields);
    $node_list = array();
    // CREATE MARKER INFO
    foreach ($nodes as $k => $v) {
      if ( ! array_key_exists($v->nid, $node_list) ) {
        $node_list[$v->nid] = True;
        // Latitude
        $lat = $data->geo_lat;
        $lat = $v->$lat;

        // Longitude
        $lng = $data->geo_lng;
        $lng = $v->$lng;

        // Nid & Title
        $nid = $v->nid;
        $title = $v->node_title;

        // Applies Views field handlers
        $sort_fields = array();
        foreach ($view->field as $field) {
          if ($fields[$view->field[$k]['id']]['visible'] !== FALSE) {
            $field_name = $field['queryname'];
            $v->$field_name = views_theme_field('views_handle_field', $field_name, $fields, $field, $v, $view);
            $sort_fields[] = $field_name;
          }
        }
        
        // Format Extra
        // Info Window
        $extra = gproximity_format_extra($data->format,$v,$data->additional_fields);
        if ($v->node_title) {
          $v->node_title = preg_replace('/href="(.*)">(.*)/', 'href="$1" class="map-link">$2', $v->node_title);
        }
        // Results div
        $results_extra = gproximity_format_extra($data->results_format,$v,$data->results_additional_fields);
        foreach ($v as $key => $value) { // Loop through all to add to Place
          if ($key != $data->geo_lat && $key != $data->geo_lng && $key != $v->nid) {
            $more[$key] = $value;
          }
        }
        $icon = gproximity_set_icon($data->marker_icon, $data->marker_shadow);
      // for copability with IE
     $icon->shadow = $icon->shadow == '/' ? '' : $icon->shadow;
     $places[] = array(
          'nid' => $nid,
          'title' => $title,
          'sort_fields' => $sort_fields,
          'lat'  => $lat,
          'lng' => $lng,
          'extra' => $extra,
          'results_extra' => $results_extra,
          'icon'  => $icon
     ) + $more;
    }
    }
      // MARKERS
      $zoom[0] = $data->marker_zoom_out;
      if ($data->marker_zoom_in != 'max') {
        $zoom[1] = $data->marker_zoom_in;
      } else {
        $zoom[1] = '';
      }
      $gpMarkers->zoom = $zoom;
      $gpMarkers->places = $places;
      $locations[] = $gpMarkers;

      // CREATE MARKER GROUPS
      if (!empty($groups)) {
        foreach ($groups as $v) {
          $lats = 0;
          $lngs = 0;
          $tempGroups = NULL;
          $places = NULL;
          $count = count($gpMarkers->places);
          foreach ($gpMarkers->places as $key => $value) {
            // $tempGroups[strtolower($value[$v->field])][] = array('lat' => $value['lat'],'lng' => $value['lng'],'group' => gproximity_format_extra($v->info,(object)$value,$v->info_fields,$count));
            $tempGroups[strtolower($value[$v->field])][] = array('lat' => $value['lat'],'lng' => $value['lng']);
            $tempGroups[strtolower($value[$v->field])]['extra'] = $v->info;
            $tempGroups[strtolower($value[$v->field])]['data'] = $value;
          }

          foreach ($tempGroups as $key => $value) {
            $num = 0;
            foreach ($value as $k => $array) {
              if (is_numeric($k)) {
                $num++;
              }
            }
            $lats = 0;
            $lngs = 0;
            foreach ($value as $k => $latlng) {
              if (is_numeric($k)) {
                $lats += $latlng['lat'];
                $lngs += $latlng['lng'];
              }
            }
            $lat = $lats/$num;
            $lng = $lngs/$num;
            $icon = gproximity_set_icon($v->icon, $v->shadow);

            $group_extra = gproximity_format_extra($value['extra'],(object)$value['data'],$v->info_fields,$num);
            $places[$key] = array('lat' => $lat,'lng' => $lng,'extra' => nl2br($group_extra),'icon' => $icon);
          }
          $zoom[0] = $v->zoom_out;
          $zoom[1] = $v->zoom_in;
          $locations[] = array('zoom' => $zoom,'places' => $places);
        }
      }
    
    // MAP SETTINGS
    $settings->centerLat = $data->center_lat;
    $settings->centerLng = $data->center_lng;
    $settings->width = $data->width;
    $settings->height = $data->height;
    $settings->zoomLvl = $data->zoom_lvl;
    $settings->searchZoomLvl = $data->search_zoom_lvl;


    // Map Controls
    $settings->scale = $data->scale;
    $settings->mapType = $data->maptype;
    $settings->zoom = $data->zoom;
    $settings->overview = $data->setOverview;
    $settings->hideShow = $data->hide_show_overview;
    $settings->doubleClick = $data->doubleclick;
    $settings->scrollZoom = $data->scrollzoom;
    $settings->mapDragging = $data->map_dragging;
    $settings->continuousZoom = $data->continuousZoom;
    $settings->results_sort = $data->results_sort;
    // To use not overriden settings
    $alt_view = db_fetch_object(db_query("SELECT v.* FROM {view_view} v WHERE v.name = '%s'", $view->name));
    // Include Javascript code.
    drupal_add_js(drupal_get_path('module', 'gproximity'). '/quickSort.js', 'module'); // Functions to sort locations by fields
    drupal_set_html_head('<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key='.keys_api_get_key('gProximity', $_SERVER['HTTP_HOST']).'" type="text/javascript"></script>');
    drupal_add_js(drupal_get_path('module', 'gproximity'). '/gpMap.js', 'module');
    drupal_add_js('var mapSettings = '.drupal_to_js($settings).';'.
        'var locations = '.drupal_to_js($locations).';'.
        'var distanceLimit = '.$data->results_distance_limit.';'.
        'var gpPager = '.$alt_view->use_pager.';'.
        'var gpResultQty = '.$alt_view->nodes_per_page.';'.
        'var gpNodeLink = '.$data->results_node_link.';',
      'inline', 'header');
    // CREATE OUTPUT.
    $map = "<div id='gpMap' style='float:left; width:".$settings->width."px;height:".$settings->height."px;'></div>";
    // Results View
    if ($data->results_enabled == 1) {
      $gp_results;
      $gp_results->title = $data->results_title;
      $style_prefix = $data->results_rubber ? 'min-' : '';
      if ($data->results_width > 0) {
        $results_style_width .= $style_prefix.'width:'.$data->results_width."px; ";
      }
      if ($data->results_height > 0) {
        $results_style_height .= $style_prefix.'height:'.$data->results_height."px; ";
      }
      $results_style=" style='";
      if ($results_style_height) {
        $results_style .= $results_style_height;
      }
      if ($results_style_width) {
        $results_style .= $results_style_width;
      }
      $results_style .=" overflow: auto;'";     
      $gp_results->content = "<div id='gpResults'".$results_style."></div>";
      $gp_results->nav = "<div id='gpResultsNav'></div>";
      $results = array(theme('gproximity_results',$gp_results),$data->results_position);
    } else {
      $results = NULL;
    }

    // Search Field
    if ($data->search_enabled == 1) {
      $search = array(drupal_get_form('gproximity_search_form',$data->search_title,$data->search_field_size,$data->search_description,$data->search_show_button),$data->search_position);
    } else {
      $search = NULL;
    }

    $output = gproximity_format_page($map,$results,$search);

  } else {
    $output = t("This view has been improperly configured. Currently it can only be a 'page' type.");
  }

  return $output;
}

function gproximity_format_extra($format,$node_data,$data,$count = NULL) {
  if (!$data) {
    return '';
  }
  
  $fields = explode("|",$data);
  // Process field tokens
  foreach ($fields as $value) {
    $extra_token = token_replace($node_data->$value, 'gproximity', array('data' => $node_data));
    if (!empty($extra_token)) {
      $format = str_replace("[".$value."]", $extra_token,$format);
    /*} else if (strpos($format, "[".$value."]\r")) {
      $format = str_replace("[".$value."]\r", '',$format);*/
    } else if (strpos($format, "[".$value."]")) {
      $format = str_replace("[".$value."]", '',$format);
    }
  }
  // Repace newlines from format to html
  $format = preg_replace("/\\r/", "<br />", $format);
  // Process other tokens
  $items['data'] = $node_data;
  if ($count) {
    $items['count'] = $count;
  }
  $format =  token_replace_multiple($format, array('global' => NULL, 'gproximity' => $items));
  return $format;
}

function gproximity_search_form($title,$size,$description,$show_button) {
  $form['#attributes'] = array('onsubmit' => 'gproxSearch(this.search.value);return false;');
  $form['search'] = array(
    '#type' => 'textfield',
    '#title' => $title,
    '#description' => $description?$description:t('Enter an address to search by.'),
    '#size' => $size?$size:35,
    '#required' => TRUE
  );
  if ($show_button == 1) {
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => 'Go'
    );
  }

  return $form;
}

function theme_gproximity_results($data) {
  return "<h2 class='title'>".$data->title."</h2><div class='content'>".$data->content.$data->nav.'</div>';
}

function gproximity_format_page($map,$results,$search) {
  $layout = array();
  if ($search != NULL) {
    switch ($search[1]) {
      case "0":
        $layout[0] = "<div class='gprox_search' id='gprox_search' style='clear:both;'>".$search[0]."</div>";
        break;
      case "1":
        $layout[1] = "<div class='gprox_search' id='gprox_search' style='float:left;'>".$search[0]."</div>";
        break;
      case "2":
        $layout[2] = "<div class='gprox_search' id='gprox_search' style='clear:both;'>".$search[0]."</div>";
        break;
      case "3":
        $layout[3] = "<div class='gprox_search' id='gprox_search' style='float:left;'>".$search[0]."</div>";
        break;
    }
  }
  if ($results != NULL) {
    switch ($results[1]) {
      case "0":
        $layout[0] .= "<div class='gprox_result' id='gprox_result' style='clear:both;'>". $results[0] . "</div>";
        break;
      case "1":
        $layout[1] .= "<div class='gprox_result' id='gprox_result' style='float:left;'>".$results[0]."</div>";
        break;
      case "2":
        $layout[2] .= "<div class='gprox_result' id='gprox_result' style='clear:both;'>". $results[0] . "</div>";
        break;
      case "3":
        $layout[3] .= "<div class='gprox_result' id='gprox_result' style='float:left;'>".$results[0]."</div>";
        break;
    }
  }

  $output = $layout[0].$layout[1];
  $output.= $map;
  $output.= $layout[3].$layout[2];
  $output.= '<div class="clear-block"></div>';

  return $output;
}

function gproximity_set_icon($marker, $shadow) {
  $markerSize = image_get_info($marker);
  $shadowSize = image_get_info($shadow);

  $markerSize['width'] = ($markerSize['width'] != '') ? $markerSize['width'] : 20;
  $markerSize['height'] = ($markerSize['height'] != '') ? $markerSize['height'] : 34;

  $icon = new stdClass();
  $icon->marker = base_path().$marker;
  $icon->markerSize = array($markerSize['width'], $markerSize['height']);
  $icon->shadow = base_path().$shadow;
  $icon->shadowSize = array($shadowSize['width'], $shadowSize['height']);
  $anchor = ($markerSize['width']/2)-1;
  $icon->anchor = array($anchor, $markerSize['height']);
  $icon->infoAnchor = array($anchor, 2);

  return $icon;
}
