
if (Drupal.jsEnabled) {
  if (!geoLat && !geoLng) {
    var geoLat = null;
    var geoLng = null;
  }

  // Geocoder
  var geocoder = new GClientGeocoder(new GGeocodeCache());
  var reasons=[];
        reasons[G_GEO_SUCCESS]            = "Success";
        reasons[G_GEO_MISSING_ADDRESS]    = "Missing Address: The address was either missing or had no value.";
        reasons[G_GEO_UNKNOWN_ADDRESS]    = "Unknown Address:  No corresponding geographic location could be found for the specified address.";
        reasons[G_GEO_UNAVAILABLE_ADDRESS]= "Unavailable Address:  The geocode for the given address cannot be returned due to legal or contractual reasons.";
        reasons[G_GEO_BAD_KEY]            = "Bad Key: The API key is either invalid or does not match the domain for which it was given";
        reasons[G_GEO_TOO_MANY_QUERIES]   = "Too Many Queries: The daily geocoding quota for this site has been exceeded.";
        reasons[G_GEO_SERVER_ERROR]       = "Server error: The geocoding request could not be successfully processed.";

  $(document).ready(function() {
    var basePath = Drupal.settings.gproximity.basePath;

    getView();
    $("#edit-view-name").change(function() {
      getView();
    });

    // Marker Icon
    $("#edit-marker-icon").parent().append("<span id='marker_icon'></span>");
    if ($("#edit-marker-icon").val() != '') {
      $("#marker_icon").append("<img src='" + basePath + $("#edit-marker-icon").val()+"' />");
    }
    $("#edit-marker-icon").change(function() {
      $("#marker_icon").empty();
      if ($("#edit-marker-icon").val() != '') {
        $("#marker_icon").append("<img src='" + basePath + $("#edit-marker-icon").val()+"' />");
      }
    });

    // Cluster Icons
    $("#edit-group-icon").parent().append("<span id='gp_icon'></span>");
    if ($("#edit-group-icon").val() != '') {
      $("#gp_icon").append("<img src='" + basePath + $("#edit-group-icon").val()+"' />");
    }
    $("#edit-group-icon").change(function() {
      $("#gp_icon").empty();
      if ($("#edit-group-icon").val() != '') {
        $("#gp_icon").append("<img src='" + basePath + $("#edit-group-icon").val()+"' />");
      }
    });

    // Load Groups from database
    $.post(basePath + "admin/build/gproximity/manage_groups",{ type: 'get', name: $("#edit-view-name").val() }, function(data) {
      if (data) {
        if ($("#gpGroups").text() == 'No fields have been assigned as a group.') {
          $("#gpGroups").empty();
        }
        $("#gpGroups").append(data);
      }
    });
  });

  function getView() {
    var basePath = Drupal.settings.gproximity.basePath;
    $.post(basePath + "admin/build/gproximity/get_view",{ name: $("#edit-view-name").val() }, function(data) {
     if (data != 'empty') {
       //Append fields list
        $("#add_fields").empty().append(data);
        $("#add_group_fields").empty().append(data);
        $("#geo_lat_wrapper").empty().append('<select id="geo_lat_select" class="form-select" name="geo_lat">'+data+'</select>');
        $("#geo_lng_wrapper").empty().append('<select id="geo_lng_select" class="form-select" name="geo_lng">'+data+'</select>');
      }

      // If editing, set selects
      $("#edit-geo-lat").removeAttr("value");
      $("#edit-geo-lat").val($("#geo_lat").val());
      $("#geo_lat").change(function() {
        $("#edit-geo-lat").val($(this).val());
      });

      $("#edit-geo-lng").removeAttr("value");
      $("#edit-geo-lng").val($("#geo_lng").val());
      $("#geo_lng").change(function() {
        $("#edit-geo-lat").val($(this).val());
      });

      if (geoLat != null && geoLng != null) {
       $.each($("#geo_lat_select")[0], function(i,n) {
          if ($(n).val() == geoLat) {
            $("#geo_lat_select")[0].selectedIndex = i;
          }
        });
        $.each($("#geo_lng_select")[0], function(i,n) {
          if ($(n).val() == geoLng) {
            $("#geo_lng_select")[0].selectedIndex = i;
          }
        });
      } else {
       $("#geo_lat_select")[0].selectedIndex = 0;
       $("#geo_lng_seelct")[0].selectedIndex = 0;
      }
      $("#add_fields")[0].selectedIndex = 0;
      $("#add_group_fields")[0].selectedIndex = 0;

      // If editing, set hidden values
      if (additionalFields != '') {
        $("#edit-additional-fields").removeAttr("value");
        $("#edit-additional-fields").val(additionalFields);
      } else {
        $("#edit-additional-fields").removeAttr("value");
      }
    });

    getFields();
  }

  function getFields() {
    var basePath = Drupal.settings.gproximity.basePath;
    $.getJSON(basePath + "admin/build/gproximity/get_fields",{ name: $("#edit-view-name").val() }, function(data) {
      var result = data;
      var nodeData = result.fields + result.node;
      var groupData = data.fields + data.group;
      $("#edit-format").parent().parent().parent().children(".description").empty().append(nodeData);
      $("#edit-results-format").parent().parent().parent().children(".description").empty().append(nodeData);
      $("#edit-group-info").parent().parent().parent().children(".description").empty().append(groupData);
    });
  }

  function addFormatField(value) {
    var temp = $("#edit-format").val();
    temp+= "[" + value + "]";
    $("#edit-format").val(temp);
  }

  function geocode() {
    var address = $("#edit-location").val();
    if (address == '') {
      alert("Enter an address to geocode from.");
      return false;
    }
    // ====== Perform the Geocoding ======        
    geocoder.getLatLng(address, function (point)
      { 
        // ===== If that was successful, plot the point and centre the map ======
        if (point) {
          $("#edit-center-lat").val(point.lat());
          $("#edit-center-lng").val(point.lng());
        }
        // ====== Decode the error status ======
        else {
          // ==Look to see if the query was cached ==
          var result=geocoder.getCache().get(address);
          if (result) {
            var reason="Code "+result.Status.code;
            if (reasons[result.Status.code]) {
              reason = reasons[result.Status.code]
            }
          } else {
            var reason = "";
          } 
          alert('Could not find "'+address+ '" ' + reason);
        }
      }
    );
  }

  function addField(field,value) {
    var id = $(field).parent().parent().children(".resizable-textarea").children("span").children("textarea").attr("id");
    var temp = $("#"+id).val();
    temp+= value;
    $("#"+id).val(temp);
    $("#"+id)[0].focus();
    return false;
  }

  function addGroup(id) {
    var basePath = Drupal.settings.gproximity.basePath;
    $.post(basePath + "admin/build/gproximity/manage_groups",{ type: 'put', gpid: id, field: $("#add_group_fields").val(), zoom_out: $("#edit-group-zoom-out").val(), zoom_in: $("#edit-group-zoom-in").val(), icon: $("#edit-group-icon").val(), info: $("#edit-group-info").val() }, function(data) {
      if (data) {
        if ($("#gpGroups").text() == 'No fields have been assigned as a group.') {
          $("#gpGroups").empty();
        }
        $("#gpGroups").append(data);
      }
    });
  }

  function dropGroup(groupid) {
    id = groupid.replace(/gpGroup/,'');
    var basePath = Drupal.settings.gproximity.basePath;
    $.post(basePath + "admin/build/gproximity/manage_groups",{ type: 'drop', groupid: id }, function(data) {
      if (data == 'success') {
        $("#"+groupid).remove();
        if ($("#gpGroups").text() == '') {
          $("#gpGroups").append('No fields have been assigned as a group.');
        }
      }
    });
  }
}